import type { TextlintKernelFilterRule, TextlintKernelPlugin, TextlintKernelRule } from "@textlint/kernel";
import { TextlintRuleModule, TextlintRuleOptions } from "@textlint/types";
export type TextlintConfigPlugin = TextlintKernelPlugin & {
    filePath: string;
    moduleName: string;
};
export type TextlintConfigRule = TextlintKernelRule & {
    filePath: string;
    moduleName: string;
};
export type TextlintConfigFilterRule = TextlintKernelFilterRule & {
    filePath: string;
    moduleName: string;
};
export type TextlintConfigRulePreset = {
    id: string;
    preset: {
        rules: {
            [index: string]: TextlintRuleModule;
        };
        rulesConfig: {
            [index: string]: TextlintRuleOptions | boolean;
        };
    };
    filePath: string;
    moduleName: string;
};
export type TextlintConfigDescriptor = {
    plugins: TextlintConfigPlugin[];
    rules: TextlintConfigRule[];
    filterRules: TextlintConfigFilterRule[];
};
//# sourceMappingURL=TextlintConfigDescriptor.d.ts.map