"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.isTextlintFilterRuleReporter = exports.isPresetCreator = exports.isTextlintRuleModule = exports.hasLinter = void 0;
/**
 * detect that ruleCreator has linter function
 * @param {*} ruleCreator
 * @returns {boolean}
 */
function hasLinter(ruleCreator) {
    if (!ruleCreator) {
        return false;
    }
    if (typeof ruleCreator.linter === "function") {
        return true;
    }
    if (typeof ruleCreator === "function") {
        return true;
    }
    return false;
}
exports.hasLinter = hasLinter;
/**
 * detect that ruleCreator has fixer function
 * @param {*} ruleCreator
 * @returns {boolean}
 */
function hasFixer(ruleCreator) {
    if (!ruleCreator) {
        return false;
    }
    return typeof ruleCreator.fixer === "function" && hasLinter(ruleCreator);
}
const isTextlintRuleModule = (mod) => {
    // it is same with isRuleModule() in @textlint/kernel
    return hasLinter(mod) || hasFixer(mod);
};
exports.isTextlintRuleModule = isTextlintRuleModule;
const hasOwnProperty = Object.prototype.hasOwnProperty;
/**
 * Check if the given value is a preset object
 * @param mod
 */
const isPresetCreator = (mod) => {
    return hasOwnProperty.call(mod, "rules") && hasOwnProperty.call(mod, "rulesConfig");
};
exports.isPresetCreator = isPresetCreator;
const isTextlintFilterRuleReporter = (mod) => {
    return typeof mod === "function";
};
exports.isTextlintFilterRuleReporter = isTextlintFilterRuleReporter;
//# sourceMappingURL=is.js.map