/**
 * detect that ruleCreator has linter function
 * @param {*} ruleCreator
 * @returns {boolean}
 */
export function hasLinter(ruleCreator) {
    if (!ruleCreator) {
        return false;
    }
    if (typeof ruleCreator.linter === "function") {
        return true;
    }
    if (typeof ruleCreator === "function") {
        return true;
    }
    return false;
}
/**
 * detect that ruleCreator has fixer function
 * @param {*} ruleCreator
 * @returns {boolean}
 */
function hasFixer(ruleCreator) {
    if (!ruleCreator) {
        return false;
    }
    return typeof ruleCreator.fixer === "function" && hasLinter(ruleCreator);
}
export const isTextlintRuleModule = (mod) => {
    // it is same with isRuleModule() in @textlint/kernel
    return hasLinter(mod) || hasFixer(mod);
};
const hasOwnProperty = Object.prototype.hasOwnProperty;
/**
 * Check if the given value is a preset object
 * @param mod
 */
export const isPresetCreator = (mod) => {
    return hasOwnProperty.call(mod, "rules") && hasOwnProperty.call(mod, "rulesConfig");
};
export const isTextlintFilterRuleReporter = (mod) => {
    return typeof mod === "function";
};
//# sourceMappingURL=is.js.map