import type { TextlintRuleContextFixCommand, TextlintRuleErrorDetails, TextlintRuleError } from "@textlint/types";
import { TextlintRuleErrorPaddingLocation } from "@textlint/types";
export declare class TextlintRuleErrorImpl implements TextlintRuleError {
    message: string;
    /**
     * @deprecated use `padding` property
     */
    readonly line?: number;
    /**
     * @deprecated use `padding` property
     */
    readonly column?: number;
    /**
     * @deprecated use `padding` property
     */
    readonly index?: number;
    /**
     * padding location object
     * You can create padding value using `locator`
     */
    readonly padding?: TextlintRuleErrorPaddingLocation;
    readonly fix?: TextlintRuleContextFixCommand;
    /**
     * RuleError is like Error object.
     * It's used for adding to TextlintResult.
     * @param message error message should start with lowercase letter
     * @param [details] - the object has padding and fix info
     * @constructor
     */
    constructor(message: string, details?: number | TextlintRuleErrorDetails);
    toString(): string;
}
//# sourceMappingURL=TextlintRuleErrorImpl.d.ts.map